=begin
**
** core.rb
** 30/MAY/2008
** ETD-Software
**  - Daniel Martin Gomez <etd[-at-]nomejortu.com>
**
** Desc:
**   All the core modules and components of dradis are included in this file.
**
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end

# support classes: version information, configuration & settings management
# exception classes, design patterns
require 'core/version'
require 'core/config' 
require 'core/exception' 
require 'core/patterns'

# core interfaces for Model, View, Controller and Service objects
require 'core/interfaces'

# core classes
require 'core/model'
require 'core/controller'
require 'core/extensions'

# made the core classes available throughout the application
include Core
include Exceptions
