=begin
**
** exception.rb
** 03/AUG/2007
** ETD-Software
**  - Daniel Martin Gomez <etd[-at-]nomejortu.com>
**
** Desc:
**   All custom exceptions classes should be included in this file.
**
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end

module Core
  # Custom exception to handle the user request of exiting the application
  # gracefully.
  class DradisQuitApp < RuntimeError
    
  end
  
  module Exceptions
    class ServiceProvidersPathNotFoundException < LoadError
    end
    
    class ServiceRequestInvalidArgumentError < ArgumentError
    end

    class NotImplementedError < RuntimeError
    end
    
    module Multiverse
      class MultiversePathNotFoundException < LoadError
      end
      class UniverseParsingException < RuntimeError
      end
    end
    
    module Ui
      class UiArgumentError < ArgumentError
      end
    end
  end
end

