=begin
**
** resources.rb
** 31/JUL/2008
** ETD-Software
**  - Daniel Martin Gomez <etd[-at-]nomejortu.com>
**
** Desc:
**   This file contains the ActiveResource models that are stored in the 
** server side
**
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end

# Fix incompatibility with ruby 1.8.7
# See http://bicosyes.com/rails-2-1-con-ruby-1-8-7-broken/
begin
  String.class_eval{ remove_method :chars }
rescue NameError
  # other ruby version, OK
end

# FIXME: create a framework that would load everything in lib/ 
require 'lib/activeresource/lib/active_resource'

module Core
  module Model
    # ActiveResource models. This objects are stored in the dradis server
    module Resources
      RESTfulServer = $config.get_option(:restful_server)
      RESTfulServer += '/' unless  (RESTfulServer =~ /\/$/)

      class Note < ActiveResource::Base
        self.site = "#{RESTfulServer}nodes/:node_id"
      end
      class Node < ActiveResource::Base
        self.site = RESTfulServer
      end    
      class Configuration < ActiveResource::Base
        self.site = RESTfulServer
      end
      class Category < ActiveResource::Base
        self.site = RESTfulServer
      end      
    end
  end
end
