=begin
**
** interfaceerator.rb
** 31/JUL/2008
** ETD-Software
**  - Daniel Martin Gomez <etd[-at-]nomejortu.com>
**
** Desc:
**   Interfaceerator is the module that translates from XML into property
** objects. These can be used by the View to present the user with the 
** options as the creator defines them in universe.xml.
**
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end

module Core
  module Providers
    module Interfaceerator
      # Interfaceerator is the module that translates from XML into property
      # objects. These can be used by the View to present the user with the 
      # options as the creator defines them in universe.xml.  
      class Provider
        include Interfaces::ServiceProvider
        
        def initialize(params={})
        end
        
        # Given a hash containing extended information for a node, this method 
        # returns an XML string representing it. The expected parameters are:
        # * +extended_info+: A hash with :uid, :type and :properties.
        #
        # All parameters are required.
        def service_interfaceerator_to_xml(*args)
          if (args.size != 1)
            raise ServiceRequestInvalidArgumentError.new('Invalid parameters. Required parameters: extended_info')
          end        
          info = args[0]
          info.to_xml(:root => 'extendednode')
        end
      end
    end
  end
end