=begin
**
** multiverse.rb
** 02/JUL/2008
** ETD-Software
**  - Daniel Martin Gomez <etd[-at-]nomejortu.com>
**
** Desc:
**   All the multiverse related modules and components of dradis are 
** 'required' in this file.
**
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end

# Interfaces used by the different implementations
require 'multiverse/interfaces'

# Parse XML universe definitions
require 'multiverse/parser'

# Each defined universe, its mapped to this model
require 'multiverse/universe'

# The multiverse builder will handle all the operations with the different 
# universes
require 'multiverse/builder'

# The extended node that encapsulates the Node interface plus the universe
# related information associated with a node.
require 'multiverse/extended_node'

# The class that implements the Interfaces::ServiceProvider interface
require 'multiverse/provider'