=begin
**
** chucknorris.rb
** 18/SEP/2007
** ETD-Software
**  - Daniel Martin Gomez <etd[-at-]nomejortu.com>
**
** Desc:
**   This module is adapted from the corresponding plugin of rbot project.
** Apparently, the main author of the project as stated in the AUTHORS file is:
**
** Main Author
**   > o Tom Gilbert (giblet) <tom@linuxbrit.co.uk>
**
** Please refer to that project's web site for information on the authors:
** http://linuxbrit.co.uk/rbot/
**   
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end

require 'yaml'
require 'zlib'

module Extensions 
  
  # This module provides a helpful Chuck Norris fact. Actions provided are:
  # [+fact+] shows a random Chuck Norris fact
  # This module is adapted from the corresponding plugin of rbot project.
  # Apparently, the main author of the prject as stated in the AUTHORS file is:
  #
  # Main Author
  # * Tom Gilbert (giblet) <tom@linuxbrit.co.uk>
  #
  # Please refer to that projects web site for information on the authors:
  # http://linuxbrit.co.uk/rbot/  
  class Chucknorris < Extensions::Simple
    def initialize(params={})
      path = './extensions/chucknorris.yml.gz'
      begin
        fyml = Zlib::GzipReader.open(path)
        #yml fyml = open(path)
      rescue
        raise "Error: Couldn't find chucknorris.yml[.gz]"
      end
    
      $logger.debug{ "\t\t\t[chucknorris] Loading #{path}..." }
    
      @@facts = YAML.load(fyml).map{|fact,(score,votes)| votes >= 0 ? [score,fact] : nil}.compact
      $logger.debug{ "\t\t\t[chucknorris] #{@@facts.length} Chuck Norris facts loaded..." }
      $logger.debug{ "\t\t\tRandom fact: #{@@facts[rand(@@facts.size)].inspect}" }
    
      super
    end
  
    #===================================================== private methods
    private
    # Just a little helper for the initialize method...
    def find_facts_file(name)
      full_path = 
      found_files = Dir[full_path]
      if found_files.empty?
        nil
      else
        found_files[0]
      end
    end
  
    #----------------------------------------------------- Dispatcher implementation
    INFO = { 
      :commands => {
        'fact' => { 
          :desc => 'shows a random Chuck Norris fact', 
          :syntax => [ ]
        }
      }
    } #:nodoc:
    
    #----------------------------------------------------- commands implementation
    def fact(*args)
      @@facts[rand(@@facts.size)][1]
    end
    
    #===================================================== public methods
    public
  end


end
