=begin
**
** ip_populator.rb
** 05/AUG/2008
** ETD-Software
**  - Daniel Martin Gomez <etd[-at-]nomejortu.com>
**
** Desc:
**   This Populator fills in the :ip property using dome
**
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end

require 'socket'

module Networking
  module Populators
    class IpPopulator
      include Core::Providers::Multiverse::Interfaces::PropertyPopulator
      
      def on_invoke(params={})
        modified = []
        ip_address = IPSocket.getaddress(Socket.gethostname)
        params[:properties].each do |prop|
          next if prop.key != 'ip'
          prop.value = ip_address
          modified << prop
        end
        return modified
      end
    end
  end
end