=begin
**
** multiverse_builder_test.rb
** 03/JUL/2008
** ETD-Software
**  - Daniel Martin Gomez <etd[-at-]nomejortu.com>
**
** Desc:
**   TestCase that contains tests for the multiverse processing. i.e. check if
** the multiverse finds all the avaliable univereses, test what happens if two
** universes define the same uid, etc.
**
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end

require 'logger'
require 'test/unit'
$: <<  File.dirname(__FILE__) + '/../'
require 'core/exception'
require 'core/patterns'
require 'core/interfaces'
$: <<  File.dirname(__FILE__) + '/../core/serviceproviders/'
require 'multiverse'

class MultiverseBuilderTest < Test::Unit::TestCase
  
  def setup
    $logger = Logger.new(STDOUT)
    $logger.level = Logger::DEBUG
    $logger.level = Logger::FATAL
    $logger.datetime_format = '%H:%M:%S'
    @builder = Core::Providers::Multiverse::Builder.new(:path => './fakemultiverse/')
  end
  
  # Check that the Multiverse Builder finds all the available universes 
  def test_multiverse_size
    assert_equal 2, @builder.multiverse.size
  end
  
  # The builder should be able to handle exceptions thrown by the parser
  def test_malformed_universe
      fail
  end
  
  # What happens if the universe folder does not contain a universe.xml?
  def test_empty_universe
      fail
  end
  
  # Check that exceptions caused by two universes with the same uid are handled
  # properly
  def test_uid_collision
    fail
  end
end