=begin
**
** window.rb
** 01/FEB/2008
** ETD-Software
**  - Daniel Martin Gomez <etd[-at-]nomejortu.com>
**
** Desc:
**  Main wxWidgets application window
**
**
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end

module Ui
  # Interface to a widget that can be used to browse and display notes for
  # different annotatable object types.
  module NotesBrowserInterface        
    HTML = {
      :home => "<center><br/><img src=\"ui/images/caprica_big.jpg\"><h1>#{Core::VERSION.string}</h1>etdsoft '08</center>",
      :bar => '<div><div>actions: <a href="add/#node_id#">add note</a></div><div>show:#catlist# (<a href="filter/all">all</a>)</div></div>',
      :invalid => '<center><br/><img src="ui/qt/images/dradis.jpg"><p>please, wait until the new revision is downloaded from the server...</p></center>'
    }
          
    # Invalidate the current view as a result of an action performed by the
    # user (i.e. add a new note, edit the current note, etc.). The widget
    # should display some behaviour indicating that the current view is no
    # longer valid and the user should wait until content is refreshed from
    # the server.
    def invalidate!() Kernel.raise 'unimplemented!'; end
        
    def reload() Kernel.raise 'unimplemented!'; end
    
    # Display the default page. When a model update is received, the notes
    # browser should be brought back to the default page.
    def home() Kernel.raise 'unimplemented!'; end
        
    # Given a set of notes (_note_list_) the widge should display them.
    # Other attributes are passed to the widget in order to be returned
    # when the widget signals *editNote* or *addNote*.
    def show_notes(node_id, note_list) Kernel.raise 'unimplemented!'; end
    
    # Refresh the contents of the control with the new information provided
    # by the model.
    def update_view(model) Kernel.raise 'unimplemented!'; end    
  end

  # Interface to a widget that can be used to browse and display the properties
  # of a selected node.
  module PropertiesPaneInterface
    MSG = { 
      :home => 'Please select a node to display its properties',
      :apply => 'Apply',
      :properties => 'Properties'
    }
    
    # Returns +true+ if the user has modified any of the values presented in
    # the widget, +false+ otherwise.
    def modified?() Kernel.raise 'unimplemented!'; end
    
    # The display the properties of a given node. These are passed in an array
    # of Core::Model::Support::Property objects containing both property name, 
    # type and other associated info.
    def show_properties(node_id, properties) Kernel.raise 'unimplemented!'; end
    
    # When the user is done applying changes to the properties pane, the controller
    # needs to recover the changes made. This function returns an array of 
    # Core::Model::Support::Property objects.
    def get_properties() Kernel.raise 'unimplemented!'; end
    
    # When a module modifies the value of a property and needs the PropertyPane
    # to display the new value, then this method is called.
    def update_property(property) Kernel.raise 'unimplemented!'; end
  end

  # All custom controls/widgets of the UI that are used to display host/service
  # information should implement the following interface.
  module HostsBrowserInterface
    
    # Refresh the contents of the control with the new information provided
    # by the model.
    def update_view(model) Kernel.raise 'unimplemented!'; end
  end

  # Controls acting as a command line console should implement this interface
  # to be able to interact with the main window.
  module ConsoleInterface
    def append(line) Kernel.raise 'unimplemented!'; end
  end
end
