=begin
**
** filesystem.rb
** 19/JUN/2007
** ETD-Software
**  - Daniel Martin Gomez <etd[-at-]nomejortu.com>
**
** Desc:
**   This module uses is a proof of concept for an implementation of the
** SimpleDispatcher that provides actions related to the filesystem.
**
** License:
**   See dradis.rb or LICENSE.txt for copyright and licensing information.
**
=end

module Extensions 
  
  # This module uses is a proof of concept for an implementation of the
  # SimpleDispatcher that provides actions related to the filesystem. Actions
  # provided are:
  # [+ls+] lists entries under the directory specified as argument much in the
  #        way of the unix command.
  class Filesystem < Extensions::Simple
    #===================================================== private methods
    private
    #----------------------------------------------------- Dispatcher implementation
    INFO = { 
      :commands => {
        'ls' => { 
          :desc => 'lists entries under the directory specified as argument', 
          :syntax => [ 
            {
              :required => true,
              :label=>'path', 
              :regexp=> /.+/
            }
          ]
        }
      }
    }#:nodoc:
    
    #----------------------------------------------------- commands implementation
    def ls(*args)
      if (args==nil)||(args.size !=2)
        path = '.'
      else
        path = args[1]
      end
      
      Dir.entries(path).sort
    end
    
    #===================================================== public methods
    public

  end
end
